
;================================================================



;=================================================================
;EVENTS PART

;-----------------------------------------------------------------
pro err,event

	COMMON ShareError, error1, error2, error3, definerr

	case definerr of
		1: a = 'No bisector counted !!! '
		2: a = ' No file loaded !!!  '
		3: a = 'No intensity settings !!!'
		4: a = ' Incorrect settings!!! '
		5: a = 'Calculation error! Check settings!'
	endcase
	ErrorBase = Widget_Base( GROUP_LEADER=wGroup, UNAME='WID_BASE_3'  $
      	,XOFFSET=5 ,YOFFSET=5 ,SCR_XSIZE=200 ,SCR_YSIZE=80 ,TITLE='Error...'  $
      	,SPACE=3 ,XPAD=3 ,YPAD=3)
	ErrorLabel = Widget_Label(ErrorBase, UNAME='ErrorLabel'  $
      	,XOFFSET=20 ,YOFFSET=20 ,SCR_XSIZE=160 ,SCR_YSIZE=20  $
      	,/ALIGN_CENTER ,VALUE=a)
	Widget_Control, /REALIZE, ErrorBase
	XManager, 'ErrorBase', ErrorBase, /NO_BLOCK
	wait, 2
	widget_control,ErrorBase,/destroy

end
;-----------------------------------------------------------------



;-----------------------------------------------------------------
pro OpenFile, Event
;reading file

	COMMON Share1, a, b, c, v, soubor, delkafilu
	COMMON Share2, delkapole
	COMMON Share5, cara
	COMMON Share6, rozsah
	COMMON Share7, minp, maxp
	COMMON ShareError, error1, error2, error3, definerr

	filer = ''
	komplexcesty = filer+dialog_pickfile(/MUST_EXIST, TITLE='Pick a Data Set', FILTER='*.fts', GET_PATH=cesta, /READ)
	print, komplexcesty
	print,'path = ', cesta
	delkacesty=STRLEN(cesta)
	delkakomplex=STRLEN(komplexcesty)
	delkafilu=delkakomplex-delkacesty
	soubor=STRMID(komplexcesty,delkacesty,delkafilu)
	print,'The file to be analyzed: ',soubor

	error2 = 1

	;main array
	a =  readfits(soubor)
	delkapole = SIZE(a, /N_ELEMENTS)/2
	a(*,1) = a(*,1)/100

print, delkapole
print, a

	;wavelength(Angst) --> speed(km/s) ... via Doppler
	v = make_array(delkapole,/float)
	for i = 0,delkapole - 1 do v(i)=((-cara + a(i,0))/cara)*299792.458

	;plotting a profile and line
	b = (findgen (41) - 20) / 20
	c = intarr (41)
	d = (indgen (51) - 25) * 6
	e = fltarr (51)
	minp = min(a(*,1))

	maxp = max(a(*,1))


	plot,v,a(*,1), xtitle = 'Rychlost (km/s)', ytitle = 'Relativn intenzita', xstyle = 1, xrange = [-rozsah,rozsah], charsize = 1.3, xmargin = [7,3]
	oplot,c,b, linestyle = 2
	e(*) = minp
	oplot, d,e, linestyle = 1
	e(*) = maxp
	oplot, d,e, linestyle = 1

end
;-----------------------------------------------------------------

;-----------------------------------------------------------------
pro SavePSFile, Event
;plotting into .PS file

	COMMON Share1, a, b, c, v, soubor, delkafilu
 	COMMON Share3, bise, intenzita, chyba
 	COMMON Share4, konec
 	COMMON Share6, rozsah
 	COMMON ShareError, error1, error2, error3, definerr

	if (error1 EQ 0) then begin
		definerr = 1
		err, event
	endif else begin
		delkafilu=STRLEN(soubor)
		STRPUT,soubor,'.ps ',delkafilu-4
		print,'Graphical output into psfile: ',soubor
		mydevice=!D.NAME
		SET_PLOT,'PS'
		DEVICE,FILENAME=soubor

		plot,v,a(*,1), title = 'Bisector', xtitle = 'Rychlost (km/s)', ytitle = 'Relativn intenzita', xstyle = 1, xrange = [-rozsah,rozsah], xmargin = [7,3]
		oplot,c,b, linestyle = 2
		oplot,bise,intenzita, psym = 3

		DEVICE, /CLOSE
		SET_PLOT, mydevice
	endelse
end
;-----------------------------------------------------------------

;-----------------------------------------------------------------
pro SaveDatFile, Event
;writing into .dat file

	COMMON Share1, a, b, c, v, soubor, delkafilu
 	COMMON Share3, bise, intenzita, chyba
 	COMMON Share4, konec
 	COMMON Share6, rozsah
 	COMMON ShareError, error1, error2, error3, definerr

	if (error1 EQ 0) then begin
		definerr = 1
		err, event
	endif else begin
		delkafilu=STRLEN(soubor)
		STRPUT,soubor,'.dat ',delkafilu-4
		print,'Data output into datfile: ',soubor
		openw,1,soubor
		for i = 0, konec - 1 do begin
			if (bise(i) le rozsah) or (bise(i) ge -rozsah) and (intenzita(i) ne 0) then printf,1, intenzita(i), bise(i), chyba(i), format = '(" Intensity  (",F7.4,"), bisector  (",F7.2,") +- (",F4.2,")")'
		endfor
		close,1
	endelse
end
;-----------------------------------------------------------------

;-----------------------------------------------------------------
pro yposition_event,event

	COMMON ShareError, error1, error2, error3, definerr
	COMMON Share11, ys,yk, str
	COMMON Share12, ystart, ykonec, stred

	widget_control,event.id,get_uvalue = uvalue
	case uvalue of
	'KONEC':begin
    	    widget_control,ystart,get_value = ys
       	    widget_control,ykonec,get_value = yk
        	widget_control,stred,get_value = str
        	error3 = 1
        	widget_control,event.top,/destroy
        	end
	endcase
end
;-----------------------------------------------------------------

;-----------------------------------------------------------------
pro OnExit, Event
;end of bis.pro

	widget_control,event.top,/destroy
end
;-----------------------------------------------------------------

;-----------------------------------------------------------------
pro Vypocet, Event
;starting calculate bisectors

	COMMON Share1, a, b, c, v, soubor
	COMMON Share2, delkapole
	COMMON Share3, bise, intenzita, chyba
	COMMON Share4, konec
	COMMON Share5, cara
	COMMON Share6, rozsah
	COMMON Share7, minp, maxp
	COMMON ShareError, error1, error2, error3, definerr
    COMMON Share11, ys, yk, str

	if (error2 EQ 0) then begin
		definerr = 2
		err, event
	endif else begin

	if (error3 EQ 0)then begin
		definerr = 3
		err, event
	endif else begin


	;intensities from settings
	error1 = 1
	ys = float(ys)
	yk = float(yk)
	str = float(str)

	if 	(ys(0) EQ yk(0)) or $
		(ys(0) LT minp) or (yk(0) LT minp) or $
		(ys(0) GT maxp) or (yk(0) GT maxp) or $
		(ys(0) LT -0.2000) or (yk(0) LT -0.2000) or $
		(ys(0) GT 1.5000) or (yk(0) GT  1.5000) or $
		(str(0) LT -100) or $
		(str(0) GT +100) then begin definerr = 4
		err, event
	endif else begin

	;making array for intensity range setted
	apomocne1 = make_array(delkapole,/float)
		for i = 0, delkapole - 1 do apomocne1(i) = v(i) - str
		apomocne1 = abs(apomocne1)
		minstr = min(apomocne1,min_indexstr)
	apomocne2 = make_array(min_indexstr + 1,/float)
		for i = 0, min_indexstr do apomocne2(i) = abs(a(i,1) - ys)
		mins = min(apomocne2,min_indexs)
		for i = 0, min_indexstr do apomocne2(i) = abs(a(i,1) - yk)
		mink = min(apomocne2,min_indexk)
	if (min_indexk LT min_indexs) then begin min_indexkpom = min_indexk
										 min_indexk = min_indexs
										 min_indexs = min_indexkpom
								   	   endif
	konec = min_indexk - min_indexs + 1

	bise=make_array(konec,/float)
	chyba=make_array(konec,/float)
	intenzita=make_array(konec,/float)

	;starting calculation of a bisector
	for i = 0, konec - 1  do begin
		l = fltarr (konec)
		;eliminate 'jumps' on the right side
		for s = 0, konec - 1 do l(s) = a(min_indexs + s,1) - a(min_indexs + i, 1)
		priznakmin = 0
		priznakplus = 0
		for t = i + 1, konec - 1 do begin
		 	if (l(t) le 0) then priznakmin = 1
		 	if (l(t) ge 0) then priznakplus = 1
		endfor
		if ((priznakmin ne 1) or (priznakplus ne 1)) then begin
			;finding intezity and wavelength from left side
			levastrana = a(min_indexs + i,1)
			vlnovadelka1 = a(min_indexs + i ,0)
			;starting calculation of equivalent from right side
			k = fltarr(delkapole-min_indexstr - 1)
			for j = min_indexstr + 1, delkapole - 1 do k(j - min_indexstr - 1) = a(j,1) - levastrana

			;finding subscripts from right side
			mink = min (abs (k),min_indexprav)
			;if there is exactly measured point on the right side too
			if (k(min_indexprav) eq 0) then begin
				vlnovadelka2 = a(min_indexprav + min_indexstr + 1,0)
				Intenzita(i)=levastrana
				chyba(i) = 0
			endif else begin
				kpom2 = 10000
				for j = 0, delkapole-min_indexstr - 3 do begin
				if (abs(k(j)) LE 0.30) then begin
					if ((k(j) LT 0) and (k(j+1) GT 0)) or ((k(j) GT 0) and (k(j+1) LT 0)) then begin if (j LT kpom2) then kpom2 = j
       	         			endif
       	  	    		endif
       	 		endfor
				if (kpom2 eq 10000) then begin definerr = 5
					err, event
					goto, label
				endif
				indexprac1 = kpom2 + min_indexstr + 1
				indexprac2 = kpom2 + min_indexstr + 2
				y = fltarr(2)
				x = fltarr(2)
				x(0) = (a(indexprac1,0)- cara)/cara*299792.458
				x(1) = (a(indexprac2,0)- cara)/cara*299792.458
				y(0) = a(indexprac1,1)
				y(1) = a(indexprac2,1)
				;interpolation velocity from right side of a profile
				resultk = (y(0)-y(1))/(x(0)-x(1))
				resultq = (x(1)*y(0)-x(0)*y(1))/(x(1)-x(0))
				rychlost2 = (levastrana - resultq)/resultk
			 	;errors of a calculation

				;=======================================================
				;upravit tohle dle chyb disperzni a kalibracni krivky!!!
				;=======================================================

				Chyba(i) = abs (v(indexprac1) - v(indexprac2)) - abs(v(indexprac1) - v(indexprac2)) / 10
				Intenzita(i)=levastrana

			endelse
				;final wavelength or speed
				rychlost1 = (vlnovadelka1 - cara)/cara*299792.458
				Bise(i) = (rychlost2 - rychlost1) / 2 + rychlost1
			endif
		endfor

	;final plotting
	oplot, bise, intenzita, psym = 3
	;...and printing data
	for i = 0, konec - 1 do begin
		if (bise(i) le rozsah) or (bise(i) ge -rozsah) and (intenzita(i) ne 0) then print, intenzita(i), bise(i), chyba(i), format = '(" Intensity  (",F7.4,"), bisector  (",F6.1,") +- (",F3.1,")")'
	endfor

	endelse
	endelse
	endelse

label:
end
;=================================================================

;=================================================================
;WIDGET PART

;-----------------------------------------------------------------
pro Yps, event

	COMMON Share11, ys, yk, str
	COMMON Share12, ystart,ykonec, stred
	COMMON ShareError, error1, error2, error3, definerr

	if (error2 EQ 0) then begin
		definerr = 2
		err, event
	endif else begin

	rangebase = widget_base(title='Intensity settings',/column)
	ystart = cw_field(rangebase,title = 'Upper Intensity  ')
    ykonec = cw_field(rangebase,title = 'Lower Intensity  ')
    stred = cw_field(rangebase,title = 'Profile''s Core     ')
    konecbase = widget_base(rangebase,/row)
    okbut = widget_button(konecbase,value = 'OK',uvalue = 'KONEC')
    widget_control,rangebase,/realize
    xmanager,'yposition',rangebase
    endelse
end
;-----------------------------------------------------------------

;-----------------------------------------------------------------
pro BisBase_event, Event

	COMMON Share4, konec
	COMMON Share5, cara
	COMMON ShareError, error1, error2, error3, definerr

    wWidget =  Event.top
	case Event.id of
		Widget_Info(wWidget, FIND_BY_UNAME='MENU_2'): begin
      		if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then OpenFile, Event
    	end
    	Widget_Info(wWidget, FIND_BY_UNAME='MENU_3'): begin
      		if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then SavePSFile, Event
    	end
    	Widget_Info(wWidget, FIND_BY_UNAME='MENU_4'): begin
      		if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then SaveDatFile, Event
    	end
    	Widget_Info(wWidget, FIND_BY_UNAME='BUTTON_1'): begin
      		if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then SavePSFile, Event
    	end
    	Widget_Info(wWidget, FIND_BY_UNAME='BUTTON_2'): begin
      		if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then SaveDatFile, Event
    	end
    	Widget_Info(wWidget, FIND_BY_UNAME='MENU_5'): begin
      		if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then OnExit, Event
    	end
    	Widget_Info(wWidget, FIND_BY_UNAME='BUTTON_0'): begin
      		if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then Vypocet, Event
    	end
    	Widget_Info(wWidget, FIND_BY_UNAME='BUTTON_3'): begin
      		if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then Yps, Event
    	end
    	Widget_Info(wWidget, FIND_BY_UNAME='DROPLIST_0'): begin
      		if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then print, 'Drop'
      			case event.index of
      				0: cara = 6562.827
      				1: cara = 4861.342
      				2: cara = 8542.144
      			endcase
    	end
  endcase

end
;-----------------------------------------------------------------

;-----------------------------------------------------------------
pro BisBase, GROUP_LEADER=wGroup, _EXTRA=_VWBExtra_

  	BisBase = Widget_Base( GROUP_LEADER=wGroup, UNAME='BisBase'  $
      	,XOFFSET=5 ,YOFFSET=5 ,SCR_XSIZE=906 ,SCR_YSIZE=735  $
      	,TITLE='Bisec' ,SPACE=3 ,XPAD=3 ,YPAD=3 ,MBAR=BASE_MBAR)
	MENU_1 = Widget_Button(BASE_MBAR, UNAME='MENU_1' ,/MENU,VALUE=' File ')
	MENU_2 = Widget_Button(MENU_1, UNAME='MENU_2' ,VALUE='Open')
	MENU_3 = Widget_Button(MENU_1, UNAME='MENU_3' ,VALUE='Save As PS')
	MENU_4 = Widget_Button(MENU_1, UNAME='MENU_4' ,VALUE='Save Data')
	MENU_5 = Widget_Button(MENU_1, UNAME='MENU_5' ,/SEPARATOR,VALUE='Exit')

	DRAW_0 = Widget_Draw(BisBase, UNAME='DRAW_0' ,XOFFSET=25,YOFFSET=35 ,SCR_XSIZE=850 ,SCR_YSIZE=630)

	BUTTON_0 = Widget_Button(BisBase, UNAME='BUTTON_0'  $
      	,XOFFSET=8 ,YOFFSET=2 ,SCR_XSIZE=65,SCR_YSIZE=25,/ALIGN_CENTER ,VALUE='Calculate')
	BUTTON_1 = Widget_Button(BisBase, UNAME='BUTTON_1'  $
      	,XOFFSET=90 ,YOFFSET=2 ,SCR_XSIZE=60,SCR_YSIZE=25,/ALIGN_CENTER ,VALUE='Save PS')
	BUTTON_2 = Widget_Button(BisBase, UNAME='BUTTON_2'  $
      	,XOFFSET=150 ,YOFFSET=2 ,SCR_XSIZE=60,SCR_YSIZE=25,/ALIGN_CENTER ,VALUE='Save Data')
    DROPLIST_0 = Widget_Droplist(BisBase, UNAME='DROPLIST_0'  $
      	,XOFFSET=227 ,YOFFSET=4 ,SCR_XSIZE=70 ,SCR_YSIZE=25 ,VALUE=[  $
      	'H alpha', 'H betta', 'Ca II'])
    BUTTON_3 = Widget_Button(BisBase, UNAME='BUTTON_3'  $
    	,XOFFSET=310 ,YOFFSET=2 ,SCR_XSIZE=60,SCR_YSIZE=25,/ALIGN_CENTER ,VALUE='Settings')

  	Widget_Control, /REALIZE, BisBase
	XManager, 'BisBase', BisBase, /NO_BLOCK
end
;-----------------------------------------------------------------

;=================================================================
;MAIN

;-----------------------------------------------------------------
pro Bisec, GROUP_LEADER=wGroup, _EXTRA=_VWBExtra_
  	BisBase, GROUP_LEADER=wGroup, _EXTRA=_VWBExtra_

	COMMON Share5, cara
	COMMON Share6, rozsah
	COMMON ShareError, error1, error2, error3
	COMMON Share11, ys, yk, str

	rozsah = 150
	cara = 6562.827
	error1 = 0
	error2 = 0
	error3 = 0
	ys = ' '
	yk = ' '
	str= ' '
end
;=================================================================